Overview

FlashDigger Plus (registered version) | FlashDigger Lite (freeware version)
Includes all basic features, such as graphics and sounds extraction and has a couple of advanced features including SWF file editing, text, graphics, sounds updating and more. All basic features are available for free, advanced features require registration. | Can explore SWF files and extract a graphic and sound data from them.

Basic Features (available for free in both versions):

Graphic data can be saved in JPEG and PNG formats. Transparent images are saved in PNG format with alpha channel. Both 8-bit and 24bit (True Color) transparent images are supported. A special kind of true-color transparent JPEG images, available in SWF files, are saved in true-color PNG format to preserve the transparency.

Sound data are saved in MP3 or WAV format (with the same compression type as they were stored inside SWF).

You can create a mute SWF file (i.e all the movie but the soundtrack).

Also you can explore the full SWF file listing, including all SWF tags, present in the current file.including ActionScript® scripts.

FlashDigger Plus [image] (registered version) also can:

Export Graphics in various formats - it is possible now to choose additional formats (such as BMP) for saving graphics, originally stored in JPEG and PNG format. Transparent JPEG's (a special kind of graphics, available in SWF) can be saved as a normal JPEG and transparency mask (a 8-bit grayscale BMP format) pair. Shapes are saved in Enhanced Metafile (EMF) format.

Update Graphics - you can easily update a bitmaps in your SWF file without its rebuilding. Now it is possible to update any graphics by few mouse clicks.

Update Text - you can easily update a text objects in your SWF file without its rebuilding. Now it is possible to update any text by few mouse clicks.

Edit Shape Objects - you can edit a shape objects, using (still) non-visual Property Editor.

Update Button URL - you can easily update a broken/out of date hyperlink, assigned to a button object.

Edit Button Shapes - you can edit a shape objects, associated with a button object.

Edit Button Actions - you can edit a script, asociated with a button object.

Update Event/Streaming Sounds - both event (button or frame) and streaming sounds can be updated by new sound in MP3 format.

Apply Soundtrack to Clip/Movie - applies a soundtrack (streaming sound in MP3 format) to any clip object, defined in the main SWF movie. Soundtrack is aligned to clip duration.

Change Scene Size - You can resize your movie and/or change its frame rate.

Assign Hyperlink Entire Scene - want to assign a hyperlink to your clip? No problem! Just select a frame and click a toolbutton!

Assign Hyperlink to a Rectangular Area - works like above, but you can specify a rectangular area to apply a hyperlink. Very useful for large clips with rich content.

Remove an Object - you can remove any object from screen. It is done not by a "physical" removal, but just by a RemoveObject2 SWF tag insertion. In this way you can delete any object, earlier placed on the screen.

Remove Tags or Frames from the SWF file. So, you can cut some parts, remove some effects and so on.

Save any selected portion of the original SWF file into another SWF file.

Compress and Decompress SWF files in the same way as FlashMX does it.

Import SWF from Projector (EXE) files. You can extract SWF source from Macromedia Projector and IceProjector executables.

Convert SWF files to EXE. It is not a usual Macromedia Projector, but a highly customizable EXE which doesn't require any Macromedia stuff presence on a user's PC.

Additional Tools are available in the FlashDigger Plus [image] version:

MP3 Encoder - can encode uncompressed WAV files into MP3 format compatible with SWF standard. You can use it if you have MP3 file with sampling rate or other parameters incompatible with SWF standard.

Sound Uncompressor - can convert sound from any multimedia format, supported by your Windows system (such as mp3, asf, wma, wmv, etc.) into uncompressed WAV format.Also can extract soundtrack from video files, such as AVI or MPEG. This tool is very useful if your sounds are in other formats than MP3, compatible with SWF standard.

Sound Recorder - can record sound from any source and save it in WAV or MP3 format.


Export Graphics

How to export a graphic object:

Open a SWF file.

Select an object from the Objects Tree.

Choose filename to save with. Optionally you can choose a folder to save exported resources.

Click «Export Object» toolbutton.

Graphic Export Formats
SWF Graphic Type | Exported Graphic Format
JPEG Format | JPEG format
Transparent JPEG Format | PNG format with Alpha channel
PNG Format | PNG format


Export Sound

How to export a sound object:

Open a SWF file.

Select an object from the Objects Tree.

Choose filename to save with. Optionally you can choose a folder to save exported resources.

Click «Export Object» toolbutton.


Export Mute SWF

How to export a mute SWF copy:

Open a SWF file.

Click «Export Mute SWF» toolbutton.


Browse SWF Transcript

How to browse SWF transcript:

Open a SWF file.

Click «Transcript» toolbutton.


Export Graphics

How to export a graphic object:

Open a SWF file.

Select an object from the Objects Tree.

Choose filename to save with. Optionally you can choose file format to save exported graphic resource. See the table below for details.

Click «Export Object» toolbutton.

Graphic Export Formats
SWF Graphic Type | Exported Graphic Format
JPEG Format | JPEG format BMP 24 bit (true color) format BMP 8 bit (256 color) format
Transparent JPEG Format | PNG format with Alpha channel JPEG format + BMP alpha mask BMP format + BMP alpha mask
PNG Format | PNG format BMP 24 bit (true color) format BMP 8 bit (256 color) format
Shape Object | Enhanced Metafile (EMF) format


Update Graphics

How to update a graphic object:

Open a SWF file.

Select an object from the Objects Tree and double-click it.

«Transcript» panel will be opened and the object's definition tag will be selected automatically.

Click «Update Graphics» toolbutton.

A dialog will appear where you need:

Choose the source graphic format.

Choose the target (SWF) graphic type.

Choose the source file.

Choose the file with transparency (Alpha channel) mask if it is required by the source and target graphic types combination.

Choose JPEG compression quality if you will convert BMP or PNG format into JPEG.

Click «OK» button to finish.


Edit Shape Object

How to edit a shape object:

Open a SWF file.

Select an object from the Objects Tree and double-click it.

«Transcript» panel will be opened and the object's definition tag will be selected automatically.

Click «Properties» toolbutton.

A dialog will appear where you need:

Choose Shape Properties Group, such as Fill Style, Line Style or Shape Record.

Choose a particular property inside the property group to edit.

Change property value.

Click «OK» button to finish. Of course you can modify several properties and then click OK button to save all of them at a time.


Fonts and Text Objects

You'll see a fonts and text objects when you'll open a SWF file containing embedded fonts and text objects. Look at the screenshot to see how they are shown in the Objects Tree.

IMPORTANT: Only embedded fonts and static text objects are supported in this version. Device fonts and Dynamic texts are not supported, though they are reflected in the Objects Tree and Transcript Tree.

Working with fonts.

You can't update fonts directly. Usually fonts are updated automatically when a text object is updated or a new text object is created. In the case if some characters, used in the new text, are missing in the existing font a new font object is created, containing these missing characters. In this way total file size is kept as small as possible. The only thing you can do with font object is to inspect what characters it contains. Use Properties toolbutton for that.

Working with text objects.

You can work with text objects in either of the next ways:

 | You can update an existing text object.
 | You can add a new text object to the scene.
 | You can change text object properties, such as position, height and color for each individual line of text.
 | You can change each character properties inside each line of text.
All of these ways are described in the next chapters.


Font Properties

How to inspect font object:

Open a SWF file.

Select DefineFontInfo, DefineFontInfo2 or DefineFont2 tag to inspect.

Click «Properties» toolbutton.

A dialog appears where you can see all the characters defined in the current font object.

Usually not all characters are placed into SWF file, but only those characters which are used in particular text objects placed into the movie.

As a rule, different text objects share the same font object in the case if they're using the same font. In this way SWF file size is reduced as much as possible.


Update Existing Text

How to update an existing text:

Open a SWF file.

Choose a Text Object in the Objects tree. Double-click it.

A DefineText or DefineText2 tag will be selected automatically in the Transcript tree.

Click «Update Text» toolbutton.

A dialog appears where you can update the text object chosen.

Embedded Fonts.
You can choose the font for the updated text. By default it will be the font of the first text record of the text object. Let's call it «Embedded Font».

Available Fonts.
Usually an updated text may contain characters, missing in the existing font. In this case you'll must assign a font to use for these characters from the fonts, available in your Windows system. Let's call it «Available Font». Available font will be changed each time you change the embedded font. FlashDigger will try to find a font with the same name among the fonts, installed in your Windows system. In the case if there is no such font the first available font will be selected.

Font Search Engine.
You can try to search for a missing font using our special tool - Font Search Engine. It lets you find the font by name using FlashDigger online database, located at FlashDigger webserver. This database contains around 8,000 links to several Internet sites, containing free TrueType fonts. Please note that our database contains just a links (URLs) to a third party Internet resources - it doesn't contain a font files. Therefore there is a chance that some link may be temporarily or permanently unavailable. Nevertheless FlashDigger Support team tries to maintain this database in the actualized state.

Text Editor.
Text Editor lets you modify text. You can insert one or more lines of text. No automatic text aligning will be made, therefore please perform aligning using space characters.

Text Attributes.
You can change the text attributes such as text height, line height, tracking value and color of the text. Text Height is the maximum height of the characters in line. Line Height is the distance between bottoms of two subsequent lines of text. Tracking Value defines how closely two subsequent characters will be placed in the line of text. Text Color defines the color of all the text - not for each line. Though you can change each line color using Text Properties Editor.

IMPORTANT NOTICE: Unfortunately SWF format doesn't store text tracking data. These data are left in .FLA file. Therefore we never know what is the "original" character width - we only know what is the width of the character in particular line of text. This may lead to an incorrect character's positioning when an "old" and "new" characters are combined in the updated text.
It is recommended to reset tracking of the existing text in the case if text has been placed with a non-standard tracking value. After that you must save text changes and remove tracking information, using popup menu. After that you'll can modify the text.
Use Character Properties Editor in the case if some characters still will have an incorrect positions.

Fortunately there is a simple way to escape from these troubles: just don't use an embedded (existing) fonts for the updated text. In this case a new font will be imported into the SWF file and all characters will be at the right places. Of courcse, this method will increase SWF file size by a value taken by a new font object. Usually it is about few kB.


Create New Text

How to create a new text:

Open a SWF file.

Choose a line in the Transcript tree where to insert a new text object.

Click «Object Boundary» toolbutton. Boundary Rectangle will appear. You can adjust its position as easy as to drag it by mouse and resize it using either of eight highliting rectangles.

Click «New Text» button.

A dialog appears where you can update the text object chosen.

Placing Level.
As you maybe know, each object in the Flash movie takes its own level. None two objects take the same level. We'll use «Level» term here because Layer term, used in Flash MX authoring tool, is not just the same as Level in SWF format.
You can choose level where to place the new text. By default it will be the topmost free level in the movie. Sometimes it is nesessary to place the new text into some predefined level, e.g. between some predefined objects. In this case you can adjust Level value as you need. Level chosen will be freed by shifting all objects by one level up. Unfortunately there are a seldom special cases when it is impossible to shift objects. An error message will be displayed in this case.

Word Wrapping.
You can enable or disable word wrapping when text is rendered inside the bounding box. Text will be placed "as is" in the case if word wrapping is off. Each new line of text will appear just as it was in the text editor box. If word wrapping in on then a new line of text will be started when text width reaches the bounding box width. It is assumed that each new line in the text editor will be placed as a new line.

Hyphenation.
You can choose hyphenation mode when word wrapping mode is on. In this case rightmost word in line will be hyphenated in the case if it overflows the right text boundary. Hyphenation process is fully automated. It makes text block to be more compact and look better.

IMPORTANT NOTICE: In fact text block will be rendered inside a bottomless rectangular area, though you see a rectangular boundary with the bottom boundary on. This is not a bug - this is a manner in which text rendering works.


Inside Text Oject

Each text object consists of the next parts:

Bounding Rectangle. This is the boundary of the text which covers all text's lines.

Text Transforming Matrix. It may contain an information about total text transformation such as rotation, skew and translation. Usually it is empty, because all text transformations are defined outside of the text object.

Text Records. Text Object consists of the Text Records. Each Text Record defines a sequence of characters with the same font/size/color values. In other words a new Text Record is created each time text changes its parameters or text position is changed (e.g. at the begininning of a new line of text). You can change some text parameters using Text Properties Dialog.

Glyph Entries. Each Text Record consists of the Glyph Entries. Each Glyph Entry defines a single character. You can adjust individual characters in the line of text using Text Properties Dialog.


General Text Properties

There are the next properties defined for each text record:

Flags. They define whether text record contains a property or not. A property value is ignored in the case if corresponding flag is turned off.

Font ID. It defines what is the font for the characters in this text record. All fonts defined in the SWF movie are numbered and Font ID is the number of the font.

Text Color. Text Color is defined as Red/Green/Blue triade containing values from 0 to 255 for each color channel.

Text Placement. These values define initial (lower left corner) position of the characters sequence. TextHeight defines the maximal height of characters in the sequence.


Character Properties

Each character (glyph) in the text record has the next properties:

Index. This is an ordering number of the glyph's position inside the font object definition. This is not an ASCII code! As it was described earlier, usually font object contains just a definitions for characters in use. Therefore the numbering (indexing) of the characters inside the font starts from zero despite of the character code. Nevertheless all glyphs in the font object are always ordered by character's code. So, the blank character, having ASCII code of 32, if presents, will always be the first glyph in the font. It will have the index of zero.
You can see at the screenshot that "D" letter has index of 2. This is because "A" letter has index of 0 and "C" letter has index of 1.

Advance. This value defines the width of the current character. More precisely it is the distance between the left side of the current character and the left side of the next character. In this way we can modify this value to change the text tracking. You can change this value if you see some incorrectness in a character position.


Update Button URL

How to update an URL, associated with a button object:

Open a SWF file.

Select a button object from the Objects Tree and double-click it.

«Transcript» panel will be opened and the button object's definition tag will be selected automatically.

Click «Update URL» toolbutton.

A dialog will appear where you need:

Enter new URL to associate with the button object.

Optionally assign a Target property for the URL opening in a special browser's frame. There are few predefined targets like _blank, _top, etc.

Click «OK» button to finish.


Edit Button Shapes

How to edit a shape object, associated with a button object:

Open a SWF file.

Select a button object from the Objects Tree and double-click it.

«Transcript» panel will be opened and the button object's definition tag will be selected automatically.

Click «Properties» toolbutton.

A dialog will appear, containing the button properties.

Each button has one or more button records, containing shape character references, defining the button shape (look-and-feel) in several button states like Up, Down, Hit, etc. All what you need to do here is to find a button state you need and learn what is the shape object, defining the button in this state. After that you can find this shape object (by object ID) in the Objects Tree and modify its properties, as it is described in the Edit Shape Object section.

IMPORTANT: button may have more than one button record for the same button state in the case if button consists of many shapes. Each button record assigns just one shape object as a button part.


Edit Button Actions

How to edit a ActionScript®, associated with a button object:

Open a SWF file.

Select a button object from the Objects Tree and double-click it.

«Transcript» panel will be opened and the button object's definition tag will be selected automatically.

Click «Properties» toolbutton.

A dialog will appear, where you need:

Choose a Button Event to edit.

Choose an Action from the script, associated with the event chosen.

Modify the action chosen using the Property Editor.

Click «OK» button to save changes or «Cancel» - to discard them.


Update Event/Streaming Sound

How to update a sound object:

Open a SWF file.

Select an object from the Objects Tree and double-click it.

«Transcript» panel will be opened and the object's definition tag will be selected automatically.

Click «Update Sound» toolbutton.

A dialog will appear where you need:

Choose a source sound for updating. Sound must be in MP3 format of either 11025, 22050 or 44100 Hz sampling rate. SWF player cannot play other sampling rates (like 5500 or 8000 Hz). In this case please use Sound Uncompressor / MP3 Compressor tandem to convert your sound into a proper sampling rate.

Click «OK» button to finish.


Apply Soundtrack to Movie

How to apply a soundtrack to SWF movie:

Open a SWF file.

Choose File/Apply SoundTrack main menu item.

A dialog will appear where you need:

Choose a source sound to apply. Sound must be in MP3 format of either 11025, 22050 or 44100 Hz sampling rate. SWF player cannot play other sampling rates (like 5500 or 8000 Hz). In this case please use Sound Uncompressor / MP3 Compressor tandem to convert your sound into a proper sampling rate.

Optionally change the soundtrack duration. In this way you can cut off some trailing portion of the source soundtrack.

Optionally you can choose a movie alignment to the new soundtrack. In the case if new soundtrack's duration exceeds the movie duration a number of empty frames will be added to the movie end. In the case if Soundtrack is shorter than movie some trailing empty frames will be removed from the movie. Please note that just empty frames will be removed in this case. I.e. movie will be reduced up to the last non-empty frame.

Click «OK» button to finish.


Apply Soundtrack to Clip Object

How to apply a soundtrack to a clip object:

Open a SWF file.

Choose a Clip object in the «Transcript» TreeView. Clip must have more than one frame.

Click Edit/Apply Sound to Clip menu item.

A dialog will appear where you need:

Choose a source sound to apply. Sound must be in MP3 format of either 11025, 22050 or 44100 Hz sampling rate. SWF player cannot play other sampling rates (like 5500 or 8000 Hz). In this case please use Sound Uncompressor / MP3 Compressor tandem to convert your sound into a proper sampling rate.

Click «OK» button to finish.


Change Scene Size

How to change scene size:

Open a SWF file.

Choose Edit/Change Scene Size... main menu item.

A dialog will appear where you need:

Set new values for your movie's scene dimensions. Scene dimensions are measured in TWIPS (1/20 of point). In this way width of 320 pixels will be 6400 TWIPS.

Optionally you can change movie frame rate.

Click «OK» button to finish.


Assign Hyperlink Entire Scene

How to assign a hyperlink to all the scene:

Open a SWF file.

Choose Edit/Assign Hyperlink/Entire Clip main menu item.

A dialog will appear where you need:

Assign an URL to associate with the transparent button object.

Optionally assign a Target property for the URL opening in a special browser's frame. There are few predefined targets like _blank, _top, etc.

Click «OK» button to finish.


Assign Hyperlink for a Rectangular Area

How to assign a hyperlink for a rectangular area of the scene:

Open a SWF file.

Choose Edit/Assign Hyperlink/Show / Hide Rectangle main menu item. A highlighting rectangle will appear above the movie. It has eight small squares for resizing. You can drag this rectangle by clicking either of its boundaries.

Choose Edit/Assign Hyperlink/For a Rectangular Area main menu item.

A dialog will appear where you need:

Assign an URL to associate with the transparent button object.

Optionally assign a Target property for the URL opening in a special browser's frame. There are few predefined targets like _blank, _top, etc.

Click «OK» button to finish.


Remove an Object

How to remove an object:

Find the PlaceObject2 tag where this object is placed into the movie scene.

Choose the frame where the object should be removed. This point must be located after the PlaceObject2 tag, where this object was placed for the first time.

Click «Remove Object» toolbutton.

A dialog appears where you need to set the placing level for the object. This value must be exactly the same as it was in PlaceObject2 tag for this object.

Click «OK» button to finish.


Remove Tag or Frame

How to remove a tag or frame:

Open a SWF file.

Select a tag or frame to delete.

Click «Delete Tag/Frame» toolbutton.


Export Selected Portion of Movie

How to export a selected portion of the movie:

Open a SWF file.

Select a range (continious or not) of movie frames. You can deselect some tags inside some frames. These tags will not be exported.

Choose Export/Export Selection main menu item.


Compress/Decompress a Movie

How to compress movie:

Open a SWF file.

Choose File/Compress Movie main menu item.

Enter a compressed file name.

How to decompress movie:

Open a SWF file.

Choose File/Decompress Movie main menu item.

Enter a decompressed file name.


Import SWF Movie from EXE

How to import movie:

Choose File/Import Projector main menu item. Movie will be extracted and loaded into workspace automatically. Further you can save it as SWF or convert back to EXE (Macromedia only) format.


Convert SWF to EXE

How to convert SWF to EXE format:

Choose File/Convert SWF to EXE main menu item.

A dialog will appear where you need:

Choose a source SWF file to convert.

Choose a destination EXE filename.

Optionally choose export options (properties of the resulting EXE). E.g. whether it will have a main menu, popup menu, running in fullscreen mode, etc.

Optionally assign a custom icons for the executable.

Click «Next» button.

Assign a title for the executable's window.

Optionally enter a version, language and copyright data for the executable.

Click «Finish» button to finish.


MP3 Compressor

How to compress WAV to MP3:

Choose Tools/MP3 Compressor main menu item.

A dialog will appear where you need:

Assign a source (WAV) and target (MP3) file names. As soon as the source file will be chosen its data will be displayed. In particular you will see its sampling rate and channels mode.

Optionally assign the resampling rate for conversion to (usually) worse quality / smaller size file.

Optionally you can choose a quality preset. It is a subjective sound quality measurement unit.

Click «Encode» button to start encoding.

After encoding is finished you can evaluate the results by pressing «Play MP3» button. The file just converted will play in an embedded mediaplayer.


Sound Uncompressor

How to uncompress an audio file to WAV:

Choose Tools/Sound Uncompressor main menu item.

A dialog will appear where you need:

Assign a source (any audio format, supported by your Windows Media subsystem) and target (WAV) file names.

Click «Start» button to start uncompression.

IMPORTANT: This feature may not work or may work slowly if you have DirectX installed of version less than 8.1 (DX 9.0 or above is recommended).


Sound Recorder

How to record an audio to WAV or MP3:

Choose Tools/Sound Recorder main menu item.

A dialog will appear where you need:

Choose an audio quality to record with. This is a combination of sampling rate and MP3 compression parameters. You can find more particular information in SNDREC.INI file. You can open it by Notepad or Wordpad. Notepad is recommended.

Choose the audio source to record from.

Choose channels mode (Mono/Stereo).

It is recommended that before recording you attach an audio source to your PC and turn this source on. Then you click «Test» button and adjust the recording volume by «Volume» slider in order to achieve the best results. After that you may turn your audio source off and click «Stop» button to stop test mode. Now Sound Recorder is ready to work.

Click «Start» button to to start recording.

Click «Stop» button to to stop recording.

After recoding is finished you can evaluate the results by pressing «Play» button. The file just recorded will play in an embedded mediaplayer. Click «Stop» button to to stop the playback.


Technical Support

You can get technical support at FlashDigger homepage (www.flashdig.com or by E-mail to FlashDigger Technical Support Team. Don't hesitate to ask any questions or report a problems/bugs to us!.